﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Reflection;
#if SPYRO_LINQ2
using Spyro.Linq2;
#else
using System.Linq;
#endif

namespace $rootnamespace$.LineaComandos
{
    internal static partial class Utilidades 
    {
        internal static U ObtenerValorAtributo<T, U>(Func<T, U> p_selector)
        {
            return Assembly.GetExecutingAssembly()
                .GetCustomAttributes(typeof(T), false)
                .OfType<T>()
                .Select(p_selector)
                .SingleOrDefault();
        }
    
        internal static string ObtenerValorAtributo<T>(Func<T, string> p_selector)
        {
            return Assembly.GetExecutingAssembly()
                .GetCustomAttributes(typeof(T), false)
                .OfType<T>()
                .Select(p_selector)
                .SingleOrDefault();
        }
    
        internal static IEnumerable<string> Lineas(string p_texto)
        {
            while (!string.IsNullOrEmpty(p_texto))
            {
                var v_salto = p_texto.IndexOf('\n');
                if (v_salto > -1)
                {
                    var v_linea = p_texto.Substring(0, v_salto);
                    yield return v_linea;
                    p_texto = p_texto.Substring(v_salto + 1);
                }
                else {
                    yield return p_texto;
                    p_texto = null;
                }
            }
            yield break;
        }
    
        internal static IEnumerable<string> Lineas(string p_texto, int p_long)
        {
            while (p_texto != null)
            {
                if (p_texto.Length > p_long)
                {
                    var v_linea = p_texto.Substring(0, p_long);
                    var v_blanco = v_linea.LastIndexOfAny(new[] { ' ', '.' });
                    if (v_blanco > -1)
                    {
                        v_linea = v_linea.Substring(0, v_blanco);
                        yield return v_linea;
                        p_texto = p_texto.Substring(v_blanco + 1);
                    }
                    else {
                        yield return p_texto;
                        p_texto = null;
                    }
                }
                else {
                    yield return p_texto;
                    p_texto = null;
                }
            }
        }
    
        internal static void EscribeUso(ErrorArgumentosException e)
        {
            foreach (var v_linea in Lineas(e.Uso).SelectMany(p_linea => Lineas(p_linea, Console.BufferWidth)))
            {
                Console.WriteLine(v_linea);
                Trace.WriteLine(v_linea);
            }
        }
    }
}